* ============================================================================
* Commands for Classes TSButton, TSLines TSRadio TSTSay  Version 4.0 1/Aug/2002
* ============================================================================

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Creating Buttons from resources
*=============================================================================

#ifndef __NO_TSBUTTON__
#ifndef __NO_REDEFINE__

#xcommand REDEFINE SBUTTON [<oBtn>] ;
             [ ID <nId> ] ;
             [ <caption: PROMPT, CAPTION, TITLE> <cPrompt> ] ;
             [ <of:OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <resource: NAME, RESNAME, RESOURCE, RESOURCES> <aResource,...> ] ;
             [ <file: FILE, FILENAME, DISK> <aFile,...> ] ;
             [ <action:ACTION, EXEC, ON CLICK> <uAction,...> ] ;
             [ <help:HELP, HELPID, HELP ID> <nHelpId> ] ;
             [ MESSAGE <cMsg> ] ;
             [ WHEN <uWhen> ] ;
             [ VALID <uValid> ] ;
             [ <border: BORDER, NOBORDER, NOBOX, W97, LOOK W97, NOBOXTR> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ FONT <oFont> ] ;
             [ <lCancel: CANCEL> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ TEXT [POSITION] <nCaptPos> ] ;
             [ <lOpaque: BITMAP OPAQUE, OPAQUE> ] ;
             [ <shape: RECT, ROUND, ROUNDRECT, SHAPE, BITMAP> ] ;
             [ BRUSH <oBrush> ] ;
             [ MENU [ACTION] <uMenu,...> ] ;
             [ <lAdjust: ADJUST > ] ;
      => ;
             [ <oBtn> := ] TSButton():ReDefine( <nId>, [ \{<aResource>\} ], ;
             [ \{<aFile>\} ], <cMsg>, [{|This|<uAction>}], [<nHelpId>], ;
             [ Upper(<(border)>) ], <oWnd>, <{uWhen}>, <{uValid}>, ;
             <cToolTip>, <cPrompt>, <oFont>, <.lCancel.>, [<nCaptPos>], ;
             [ \{<aColors>\} ], <.lOpaque.>, <oBrush>, [ Upper(<(shape)>) ], ;
             [{|Self|<uMenu>}], [<.lAdjust.>] )

#endif //  __NO_REDEFINE__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Creating Buttons from code
*=============================================================================

#ifndef __NO_FROMCODE__

#xcommand @ <nRow>, <nCol> SBUTTON [<oBtn>] ;
             [ <caption: PROMPT, CAPTION, TITLE> <cPrompt> ] ;
             [ <of:OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <resource: NAME, RESNAME, RESOURCE> <aResource,...> ] ;
             [ <file: FILE, FILENAME, DISK> <aFile,...> ] ;
             [ SIZE <aSize,...> ] ;
             [ <lPixel: PIXEL, PIXELS> ] ;
             [ ACTION <uAction,...> ] ;
             [ <default: DEFAULT> ] ;
             [ FONT <oFont> ] ;
             [ MESSAGE <cMsg> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ <help:HELP, HELPID, HELP ID> <nHelpId> ] ;
             [ WHEN <uWhen> ] ;
             [ VALID <uValid> ] ;
             [ <border: BORDER, NOBORDER, NOBOX, W97, LOOK W97, NOBOXTR> ] ;
             [ <lCancel: CANCEL> ] ;
             [ <lAdjust: ADJUST > ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ TEXT [POSITION] <nCaptPos> ] ;
             [ <lOpaque: BITMAP OPAQUE, OPAQUE> ] ;
             [ <shape: RECT, ROUND, ROUNDRECT, SHAPE, BITMAP> ] ;
             [ BRUSH <oBrush> ] ;
             [ MENU [ACTION] <uMenu,...> ] ;
      => ;
             [ <oBtn> := ] TSButton():New( <nRow>, <nCol>, [<cPrompt>], ;
             [<oWnd>], [ \{<aResource>\} ], [\{<aFile>\}], [\{<aSize>\}], ;
             [<.lPixel.>], [{|This|<uAction>}], [<{uWhen}>], [<{uValid}>], ;
             [<.default.>], [<oFont>], [<cMsg>], [<cToolTip>], [<nHelpId>], ;
             [Upper(<(border)>)], [<.lCancel.>], [<.lAdjust.>], ;
             [\{<aColors>\}], [<nCaptPos>], [<.lOpaque.>], [<oBrush>], ;
             [ Upper(<(shape)>) ], [{|Self|<uMenu>}] )

#endif   // __NO_FROMCODE__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Defining Buttons for Buttonbar
*=============================================================================

#ifndef __NO_TSBAR__

#xcommand DEFINE SBUTTON [ <oBtn> ] ;
             [ <bar: OF, BUTTONBAR > <oBar> ] ;
             [ SIZE <aSize,...> ] ;
             [ <caption: PROMPT, CAPTION, TITLE> <cPrompt> ] ;
             [ <resource: NAME, RESNAME, RESOURCE, RESOURCES> <aResource,...> ] ;
             [ <file: FILE, FILENAME, FILENAMES, DISK> <aFile,...> ] ;
             [ ACTION  <uAction,...> ] ;
             [ WHEN <uWhen> ] ;
             [ FONT <oFont> ] ;
             [ MESSAGE <cMsg> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ <help:HELP, HELPID, HELP ID> <nHelpId> ] ;
             [ <border: BORDER, NOBORDER, NOBOX, W97, LOOK W97, NOBOXTR> ] ;
             [ <lCancel: CANCEL> ] ;
             [ <lAdjust: ADJUST > ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ TEXT [POSITION] <nCaptPos> ] ;
             [ <lOpaque: BITMAP OPAQUE, OPAQUE> ] ;
             [ <shape: RECT, ROUND, ROUNDRECT, SHAPE, BITMAP> ] ;
             [ BRUSH <oBrush> ] ;
             [ MENU [ACTION] <uMenu,...> ] ;
             [ <group: GROUP > ] ;
             [ AT <nPos> ] ;
             [ ON DROP <bDrop> ] ;
      => ;
         [ <oBtn> := ] TSButton():NewBar( <oBar>, [ \{<aSize>\} ], [<cPrompt>], ;
         [ \{<aResource>\} ], [ \{<aFile>\} ], [{|This|<uAction>}], ;
         [<{uWhen}>], [<oFont>], [<cMsg>], [<cToolTip>], [<nHelpId>], ;
         [ Upper(<(border)>) ], [<.lCancel.>], [<.lAdjust.>], [ \{<aColors>\} ], ;
         [<nCaptPos>], [<.lOpaque.>], [ Upper(<(shape)>) ], [<oBrush>], ;
         [{|This|<uMenu>}], [<.group.>], [<nPos>], [\{||<bDrop>\}] )

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Defining the Buttonbar
*=============================================================================

#xcommand DEFINE SBUTTONBAR [ <oBar> ] ;
             [ <size: SIZE, BUTTONSIZE, SIZEBUTTON > <nWidth>, <nHeight> ] ;
             [ <_3d: _3D, 3D, 3DLOOK, _3DLOOK> ] ;
             [ <mode: TOP, LEFT, RIGHT, BOTTOM, FLOAT> ] ;
             [ <wnd: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ CURSOR <oCursor> ] ;
             [ <lLabels: LABELS> ] ;
             [ FONT <oFont> ] ;
             [ <color: COLOR, COLORS> <nClrFore> [,<nClrBack>] ] ;
             [ BRUSH <oBrush> ] ;
      => ;
         [ <oBar> := ] TSBar():New( <oWnd>, <nWidth>, <nHeight>, <._3d.>,;
             [ Upper(<(mode)>) ], <oCursor>,  <oFont>, <.lLabels.>, ;
             <nClrFore>, <nClrBack>, <oBrush> )

#xcommand @ <nRow>, <nCol> SBUTTONBAR [ <oBar> ] ;
             [ SIZE <nWidth>, <nHeight> ] ;
             [ BUTTONSIZE <nBtnWidth>, <nBtnHeight> ] ;
             [ <_3d: 3D, 3DLOOK, _3DLOOK> ] ;
             [ <mode: TOP, LEFT, RIGHT, BOTTOM, FLOAT> ] ;
             [ <wnd: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ CURSOR <oCursor> ] ;
             [ <lLabels: LABELS> ] ;
             [ FONT <oFont> ] ;
             [ <color: COLOR, COLORS> <nClrFore> [,<nClrBack>] ] ;
             [ BRUSH <oBrush> ] ;
      => ;
         [ <oBar> := ] TBar():NewAt( <nRow>, <nCol>, <nWidth>, <nHeight>,;
             <nBtnWidth>, <nBtnHeight>, <oWnd>, <._3d.>, ;
             [ Upper(<(mode)>) ], <oCursor>,  <oFont>, <.lLabels.>, ;
             <nClrFore>, <nClrBack>, <oBrush> )

#endif __NO_TSBAR__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Creating Series or Matrixes of buttons
* <aBtn> must be an array with n elements that indicates the number of buttons
* if you want a mattrix of buttons, the array must be multidimentional
* <aAction> must be a unidimentional array with the total nuber of elements 
* <aPrompt> must be a unidimentional array with the total nuber of elements 
*=============================================================================

#ifndef __NO_FROMCODE__

#xcommand @ <nRow>, <nCol>  SBGROUP <aBtn> ;
             [ <caption: PROMPT, CAPTION, TITLE> <aPrompt> ] ;
             [ <of:OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <resource: NAME, RESNAME, RESOURCE> <aResource,...> ] ;
             [ <file: FILE, FILENAME, DISK> <aFile,...> ] ;
             [ SIZE <aSize,...> ] ;
             [ SPACE <nSpace> ] ;
             [ <lPixel: PIXEL, PIXELS> ] ;
             [ ACTION <aAction> ] ;
             [ FONT <oFont> ] ;
             [ MESSAGE <cMsg> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ <help:HELP, HELPID, HELP ID> <nHelpId> ] ;
             [ WHEN <uWhen> ] ;
             [ VALID <uValid> ] ;
             [ <border: BORDER, NOBORDER, NOBOX, W97, LOOK W97, NOBOXTR> ] ;
             [ <lCancel: CANCEL> ] ;
             [ <lAdjust: ADJUST > ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ TEXT [POSITION] <nCaptPos> ] ;
             [ <lOpaque: BITMAP OPAQUE, OPAQUE> ] ;
             [ <shape: RECT, ROUND, ROUNDRECT, SHAPE, BITMAP> ] ;
             [ BRUSH <oBrush> ] ;
             [ MENU [ACTION] <uMenu,...> ] ;
      => ;
         TSButton():NewGroup( <aBtn>, <nRow>, <nCol>, [<aPrompt>], [<oWnd>], ;
            [ \{<aResource>\} ], [ \{<aFile>\} ], [ \{<aSize>\} ], [<.lPixel.>], ;
            [<aAction>], [<{uWhen}>], [<{uValid}>], [<nSpace>], [<oFont>], ;
            [<cMsg>], [<cToolTip>], [<nHelpId>], [ Upper(<(border)>) ], ;
            [<.lCancel.>], [<.lAdjust.>], [ \{<aColors>\} ], [<nCaptPos>], ;
            [<.lOpaque.>], [<oBrush>], [Upper(<(shape)>)], [{|Self|<uMenu>}] )

#endif   // __NO_FROMCODE__

// caption position
#define ON_TOP     1 
#define ON_LEFT    2  
#define ON_BOTTOM  3
#define ON_RIGHT   4
#define ON_CENTER  5

#endif  // __NO_TSBUTTON__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Static Lines and Boxes (TSLines Now included in SButton.lib)
*=============================================================================

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Static Lines and Boxes from code
*=============================================================================

#ifndef __NO_TSLINES__
#ifndef __NO_FROMCODE__

#xcommand @ <nTop>, <nLeft> [STATIC <oLine>] ;
            <cType: HORZ LINE, HLINE, VERT LINE, VLINE, WHITE BOX, WBOX, ;
                    GRAY BOX, GBOX, BLACK BOX, BBOX> ;
            [ SIZE <nWidth> [, <nHeight > ] ] ;
            [ OF <oWnd> ] ;
            [ <Colors: COLOR, COLORS> <nClrLite> [,<nClrDark> [,<nClrText> ] ] ] ;
            [ <lPixel: PIXEL, PIXELS> ] ;
            [ <lUpdate: UPDATE> ] ;
            [ <lRounded: ROUNDED> ] ;
            [ <label:LABEL, TEXT, PROMPT> <cLabel> ] ;
            [ FONT <oFont> ] ;
            [ ALIGN <nAlign> ] ;
            [ <lDesign: DESIGN> ] ; 
       => ;
            [ <oLine> := ] TSLines():New( <nTop>, <nLeft>, <nWidth>, ;
                           <nHeight>, Upper(<(cType)>), <oWnd>, <nClrLite>, ;
                           <nClrDark>, <nClrText>, <.lPixel.>, <.lUpdate.>, ;
                           <.lRounded.>, <cLabel>, <oFont>, <nAlign>, ;
                           <.lDesign.> )

#endif   // __NO_FROMCODE__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* Static Lines and Boxes from resources
*=============================================================================

#ifndef __NO_REDEFINE__

#xcommand REDEFINE [STATIC <oLine> ] ;
            <cType: HORZ LINE, HLINE, VERT LINE, VLINE, WHITE BOX, WBOX, ;
                    GRAY BOX, GBOX, BLACK BOX, BBOX> ;
            [ ID <nId> ] ;
            [ OF <oWnd> ] ;
            [ <Colors: COLOR, COLORS> <nClrLite> [,<nClrDark> [,<nClrText> ] ] ] ;
            [ <lUpdate: UPDATE> ] ;
            [ <lRounded: ROUNDED> ] ;
            [ <label:LABEL, TEXT, PROMPT> <cLabel> ] ;
            [ FONT <oFont> ] ;
            [ ALIGN <nAlign> ] ;
            [ <lDesign: DESIGN> ] ; 
       => ;
            [ <oLine> := ] TSLines():ReDefine( Upper(<(cType)>), <nId>, ;
                           <oWnd>, <nClrLite>, <nClrDark>, <nClrText>, ;
                           <.lUpdate.>, <.lRounded.>, <cLabel>, <oFont>, ;
                           <nAlign>, <.lDesign.> )

#endif   //  __NO_REDEFINE__
#endif   // __NO_TSLINES__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* TSTSay from code
*=============================================================================

#ifndef __NO_TSTSAY__
#ifndef __NO_FROMCODE__

#xcommand @ <nRow>, <nCol> STSAY [ <oSay> <label: PROMPT,VAR > ] <cText> ;
             [ PICTURE <cPict> ] ;
             [ <dlg: OF,WINDOW,DIALOG > <oWnd> ] ;
             [ FONT <oFont> ]  ;
             [ <lCenter: CENTERED, CENTER > ] ;
             [ <lRight:  RIGHT >    ] ;
             [ <lBorder: BORDER >   ] ;
             [ <lPixel: PIXEL, PIXELS > ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ; // nClrText, nClrLight, nClrDark
             [ SIZE <nWidth>, <nHeight> ] ;
             [ <design: DESIGN >  ] ;
             [ <update: UPDATE >  ] ;
             [ <lShaded: SHADED, SHADOW > ] ;
             [ <cRaised: RAISED, BASS > ] ;
             [ BLINK <aBlink,...> ] ;
             [ WHEN <uWhen> ] ;
      => ;
          [ <oSay> := ] TSTSay():New( <nRow>, <nCol>, <{cText}>, [<oWnd>], ;
          [<cPict>], <oFont>, <.lCenter.>, <.lRight.>, <.lBorder.>, ;
          <.lPixel.>, [ \{<aColors>\} ], <nWidth>, <nHeight>, <.design.>, ;
          <.update.>, <.lShaded.>, [Upper(<(cRaised)>)], ;
          [ \{<aBlink>\} ], [<{uWhen}>] )

#endif   // __NO_FROMCODE__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* TSTSay from resources
*=============================================================================

#ifndef __NO_REDEFINE__

#xcommand REDEFINE STSAY [<oSay>] ;
             [ <label: PROMPT, VAR> <cText> ] ;
             [ PICTURE <cPict> ] ;
             [ ID <nId> ] ;
             [ <dlg: OF,WINDOW,DIALOG > <oWnd> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ; // nClrText, nClrLight, nClrDark
             [ <update: UPDATE > ] ;
             [ FONT <oFont> ] ;
             [ <lShaded: SHADED, SHADOW > ] ;
             [ <cRaised: RAISED, BASS > ] ;
             [ BLINK <aBlink,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
          [ <oSay> := ] TSTSay():ReDefine( <nId>, <{cText}>, <oWnd>, ;
                        <cPict>, [ \{<aColors>\} ], <.update.>, ;
                        <oFont>, <.lShaded.>, [Upper(<(cRaised)>)], ;
                        [ \{<aBlink>\} ], [<{uWhen}>] )

#endif   // __NO_REDEFINE__
#endif   // __NO_TSTSAY__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* TSRadio from code
*=============================================================================

#ifndef __NO_TSRADIO__
#ifndef __NO_FROMCODE__

#xcommand @ <nRow>, <nCol> SRADIO [ <oRad> VAR ] <nVar> ;
             [ <prm: PROMPT, PROMPTS, ITEMS> <cItems,...> ] ;
             [ <of: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <help:HELPID, HELP ID> <nHelpId,...> ] ;
             [ <change: ON CLICK, ON CHANGE> <uChange> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ MESSAGE <cMsg> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ <update: UPDATE> ] ;
             [ WHEN <uWhen> ] ;
             [ SIZE <nWidth>, <nHeight> ] ;           // WBOX  = white box
             [ VALID <uValid> ] ;                     // WRBOX = white rounded box
             [ <lDesign: DESIGN> ] ;                  // GBOX  = gray box
             [ <cLook3d: RAISED, BASS> ] ;            // GRBOX = gray rounded box
             [ <lPixel: PIXEL, PIXELS> ] ;            // BBOX  = black box
             [ <Fuente: FONT, FONTS> <aFonts,...> ] ; // BRBOX = black rounded box
             [ <cButton: THIN, GROSS, POINTER, CHECK, CIRCLE> ] ;
             [ <cBox: WBOX, WRBOX, GBOX, GRBOX, BBOX, BRBOX> ] ;
             [ LABEL <cLabel> ] ;
             [ ALIGN <nAlign> ] ;
       => ;
          [ <oRad> := ] TSRadio():New( <nRow>, <nCol>, [\{<cItems>\}], ;
             bSETGET(<nVar>), <oWnd>, {<nHelpId>}, <{uChange}>, ;
             [ \{<aColors>\} ], <cMsg>, <.update.>, <{uWhen}>, <nWidth>, ;
             <nHeight>, <{uValid}>, <.lDesign.>, [Upper( <(cLook3d)> )], ;
             <.lPixel.>, [\{<aFonts>\}], [Upper( <(cButton)> )], ;
             [Upper( <(cBox)> )], <cLabel>, <nAlign>, <cToolTip> )

#endif    // __NO_FROMCODE__

*=============================================================================
* TSButton.ch  Version 4.0 1/Aug/2002
* TSRadio from resources
*=============================================================================

#ifndef __NO_REDEFINE__

#xcommand REDEFINE SRADIO [ <oRad> VAR ] <nVar> ;
             [ <prm: PROMPT, PROMPTS, ITEMS> <cItems,...> ] ;
             [ ID <nId,...> ] ;
             [ <of: OF, WINDOW, DIALOG> <oWnd> ] ;
             [ <help:HELPID, HELP ID> <nHelpId,...> ] ;
             [ <change: ON CHANGE, ON CLICK> <uChange> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ MESSAGE <cMsg> ] ;
             [ TOOLTIP <cToolTip> ] ;
             [ <update: UPDATE> ] ;
             [ WHEN <uWhen> ] ;
             [ VALID <uValid> ] ;
             [ <cLook3d: RAISED, BASS> ] ;
             [ <Font: FONT, FONTS> <aFonts,...> ] ;
             [ <cButton: THIN, GROSS, POINTER, CHECK, CIRCLE> ] ;
             [ <cBox: WBOX, WRBOX, GBOX, GRBOX, BBOX, BRBOX> ] ;
             [ <Label: LABEL, BOX LABEL> <cLabel> ] ;
             [ ALIGN <nAlign> ] ;
       => ;
          [ <oRad> := ] TSRadio():Redefine( <nId>, bSETGET(<nVar>), ;
             [\{<cItems>\}], <oWnd>, [{<nHelpId>}], <{uChange}>, ;
             [\{<aColors>\}], <cMsg>, <.update.>, <{uWhen}>, <{uValid}>, ;
             [Upper( <(cLook3d)> )], \{<aFonts>\}, [Upper( <(cButton)> )], ;
             [Upper( <(cBox)> )], <cLabel>, <nAlign>, <cToolTip> )

#endif     //  __NO_REDEFINE__
#endif     // __NO_TSRADIO__

// alignment constants
#ifndef DT_LEFT
   #define DT_LEFT    0
   #define DT_CENTER  1
   #define DT_RIGHT   2
#endif
